<?php

namespace AMZcockpitDoctrine\Repository\MWS;

use AMZcockpitDoctrine\Entity\MWS\Product;
use AMZcockpitDoctrine\Entity\MWS\Store;
use AMZcockpitDoctrine\Entity\User;

/**
 * OrderItemRepository
 *
 * This class was generated by the Doctrine ORM. Add your own custom
 * repository methods below.
 */
class OrderItemRepository extends \Doctrine\ORM\EntityRepository
{
    public function getEmptyItemsByUser(User $user) {
        $qb = $this->createQueryBuilder('oi');
        $qb->select('oi')
            ->leftJoin('oi.order','o')
            ->leftJoin('o.store','s');
        $qb->where($qb->expr()->eq('s.user',':user'))
            ->setParameter('user',$user);
        $qb->andWhere($qb->expr()->isNull('oi.product'));
        return $qb->getQuery()->getResult();
    }

    public function getEmptyItemsByStore(Store $store) {
        $qb = $this->createQueryBuilder('oi');
        $qb->select('oi')
            ->leftJoin('oi.order','o');
        $qb->where($qb->expr()->eq('o.store',':store'))
            ->setParameter('store',$store);
        $qb->andWhere($qb->expr()->isNull('oi.product'));
        return $qb->getQuery()->getResult();
    }

    public function getCountByProduct(Product $product) {
        if(!$product->getId())
            return null;

        $qb = $this->createQueryBuilder('oi');
        $qb->select('SUM(oi.quantityOrdered)')
            ->leftJoin('oi.order','o')
            ->leftJoin('oi.product','p');

        $qb->where($qb->expr()->eq('oi.product',':product'))
            ->andWhere($qb->expr()->isNotNull('oi.order'))
            ->andWhere($qb->expr()->eq('p.store', 'o.store'))
            ->setParameter('product',$product);

        return $qb->getQuery()->getSingleScalarResult();
    }

    public function getOrderItemsHavingWrongProduct(User $user = null) {
        $qb = $this->createQueryBuilder('oi');
        $qb->select('oi')
            ->leftJoin('oi.order','o')
            ->leftJoin('oi.product','p');

        $qb->where($qb->expr()->neq('p.store','o.store'));

        if($user) {
            $qb
                ->leftJoin('o.store','s')
                ->andWhere($qb->expr()->eq('s.user',':user'))
                ->setParameter('user',$user);
        }
        return $qb->getQuery()->getResult();
    }
}